unit AboutClass;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DsgnIntf,AboutBox,ShellAPI;

{TAbout}
type
  TMyAboutBoxObject = class(TObject);
  TMyAboutBoxEditor = class(TPropertyEditor)
  public
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
    procedure Edit; override;
  end;
{TWyFileNameEditor}
  TWyFileNameEditor = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;
{TMyEditor}
type
  TMyEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

implementation

{ TAboutBoxEditor }
procedure TMyAboutBoxEditor.Edit;
begin
  MyAboutBox := TMyAboutBox.Create(Application);
  MyAboutBox.ShowModal ;
  MyAboutBox.Free;
end;

function TMyAboutBoxEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

function TMyAboutBoxEditor.GetValue: string;
begin
  Result := '...';
end;

{ TMyEditor }

procedure TMyEditor.ExecuteVerb(Index: Integer);
var
  windir:Array[0..255] of Char;
  dir:String;
begin
  if Index = 0 then begin
    MyAboutBox := TMyAboutBox.Create(Application);
    MyAboutBox.ShowModal ;
    MyAboutBox.Free;
  end
  else
  begin
    GetWindowsDirectory(windir,sizeof(windir));
    dir := StrPas(windir);
    WinExec(PChar(dir+'\Explorer.exe'),SW_SHOWNORMAL);
  end;
end;

function TMyEditor.GetVerb(Index: Integer): string;
begin
  if Index = 0 then
    Result := '֮'
  else
    Result := 'Դ';
end;

function TMyEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

{ TWyFileNameEditor }

procedure TWyFileNameEditor.Edit;
var
  Dialog:TOpenDialog;
begin
  Dialog := TOpenDialog.Create(nil);
  with Dialog do
  try
    FileName   := GetValue;
    Filter     := 'Executable files (*.exe)|*.exe|All Files(*.*)|*.*';
    Options    := Options + [ofHideReadOnly, ofNoDereferenceLinks];
    if Execute then SetValue(FileName);
  finally
    Free;
  end;
end;

function TWyFileNameEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paRevertable];
end;

end.
