unit MemComboBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,AboutClass;

type
  TMemComboBox = class(TComboBox)
  private
    FLbh: String;
    FLbmc: String;
    FBz: String;
    FSxh: TStrings;
    FYsbm: TStrings;
    FAbout :TMyAboutBoxObject;
    procedure SetBz(const Value: String);
    procedure SetLbh(const Value: String);
    procedure SetLbmc(const Value: String);
    procedure SetSxh(const Value: TStrings);
    procedure SetYsbm(const Value: TStrings);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    function HasItemsEqual(Item:string):boolean;
    function HasYsbmEqual(YsbmItem:string):boolean;
  published
    { Published declarations }
    property About:TMyAboutBoxObject read FAbout write FAbout;
    property Lbh:String read FLbh write SetLbh;
    property Lbmc:String read FLbmc write SetLbmc;
    property Bz:String read FBz write SetBz;
    property Ysbm:TStrings read FYsbm write SetYsbm;
    property Sxh:TStrings read FSxh write SetSxh;
  end;


implementation


{ TMemComboBox }

constructor TMemComboBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FYsbm := TStringList.Create;
  FSxh := TStringList.Create;
end;

destructor TMemComboBox.Destroy;
begin
  FYsbm.Free;
  FSxh.Free;
  inherited Destroy;
end;

function TMemComboBox.HasItemsEqual(Item: string): boolean;
var
  i:integer;
begin
  Result := False;
  if Items.Count = 0 then Result := False;
  for i := 0 to Items.Count - 1 do begin
    if Trim(Items[i])=Trim(Item) then begin
      Result := True;
      break;
    end;
  end;
end;

function TMemComboBox.HasYsbmEqual(YsbmItem: string): boolean;
var
  i:integer;
begin
  Result := False;
  if Ysbm.Count = 0 then Result := False;
  for i := 0 to Ysbm.Count - 1 do begin
    if Trim(Ysbm[i])=Trim(YsbmItem) then begin
      Result := True;
      break;
    end;
  end;
end;

procedure TMemComboBox.SetBz(const Value: String);
begin
  FBz := Value;
end;

procedure TMemComboBox.SetLbh(const Value: String);
begin
  FLbh := Value;
end;

procedure TMemComboBox.SetLbmc(const Value: String);
begin
  FLbmc := Value;
end;

procedure TMemComboBox.SetSxh(const Value: TStrings);
begin
  FSxh := Value;
end;

procedure TMemComboBox.SetYsbm(const Value:TStrings);
begin
  FYsbm := Value;
end;

end.
