unit WwwLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,ShellAPI,AboutClass;

type
  TWwwLabel = class(TCustomLabel)
  private
    { Private declarations }
    FAbout :TMyAboutBoxObject;
    FUrl:String;
    procedure SetUrl(Value:String);
    procedure TextClick(Sender:TObject);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
  published
    { Published declarations }
    property About:TMyAboutBoxObject read FAbout write FAbout;
    property Url:String read FUrl write SetUrl;
    property Align;
    property Alignment;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property Caption;
    property Color;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FocusControl;
    property Font;
    property ParentBiDiMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowAccelChar;
    property ShowHint;
    property Transparent;
    property Layout;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;


implementation


{ TWwwLabel }

constructor TWwwLabel.Create(AOwner: TComponent);
begin
  inherited;
  Parent := Application.MainForm;
  Font.Color := clBlue;
  Font.Style := [fsUnderLine];
  FUrl := Caption;
  Cursor := crHandPoint;
  Hint := FUrl;
  OnClick := TextClick;
  Visible := true;
end;

procedure TWwwLabel.SetUrl(Value: String);
begin
  if FUrl <> Value then FUrl := Value;
  Invalidate;
end;

procedure TWwwLabel.TextClick(Sender: TObject);
begin
  ShellExecute(Parent.Handle,nil,pchar(Trim(FUrl)),nil,nil,SW_SHOWNORMAL);
end;

end.
