unit DirectorySelect;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,FileCtrl;

type
  TDirDlgStyle=(ddsOldStyle,ddsNewStyle);//dir style
  TDirectorySelect = class(TComponent)
  private
    FDirDlgStyle: TDirDlgStyle;
    FDialogCaption: String;
    FRoot: String;
    FSelectDirOpts: TSelectDirOpts;
    procedure SetDirDlgStyle(const Value: TDirDlgStyle);
    procedure SetDialogCaption(const Value: String);
    procedure SetRoot(const Value: String);
    procedure SetSelectDirOpts(const Value: TSelectDirOpts);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    Directory:String;
    constructor Create(AOwner:TComponent);override;
    function Execute:boolean;
  published
    { Published declarations }
    property DirDlgStyle:TDirDlgStyle read FDirDlgStyle write SetDirDlgStyle;
    property DialogCaption:String read FDialogCaption write SetDialogCaption;
    property Root:String read FRoot write SetRoot;
    property SelectDirOpts:TSelectDirOpts read FSelectDirOpts write SetSelectDirOpts;
  end;


implementation
{$R DirectorySelect.Res}


{ TDirectorySelect }

constructor TDirectorySelect.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Directory := '';
end;

function TDirectorySelect.Execute: boolean;
begin
  Execute := False;
  if FDirDlgStyle = ddsNewStyle then
    if SelectDirectory(FDialogCaption,FRoot,Directory) then Execute := True else Execute := False
  else
  begin
    if SelectDirectory(Directory,FSelectDirOpts,0) then Execute := True else Execute := False;
  end;
  Execute := True;
end;

procedure TDirectorySelect.SetDialogCaption(const Value: String);
begin
  FDialogCaption := Value;
end;

procedure TDirectorySelect.SetDirDlgStyle(const Value: TDirDlgStyle);
begin
  FDirDlgStyle := Value;
end;

procedure TDirectorySelect.SetRoot(const Value: String);
begin
  FRoot := Value;
end;

procedure TDirectorySelect.SetSelectDirOpts(const Value: TSelectDirOpts);
begin
  FSelectDirOpts := Value;
end;

end.
