unit FontComboBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

{TFontComboBox}
type
  TFontComboBox = class(TCustomComboBox)
  private
    { Private declarations }
    function GetFontName:String;
  protected
    { Protected declarations }
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
    procedure MeasureItem(Index: Integer; var Height: Integer); override;
    procedure Loaded; override;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    property FontName :String read GetFontName ;
  published
    { Published declarations }
    property Style; {Must be published before Items}
    property Anchors;
    property BiDiMode;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property DropDownCount;
    property Enabled;
    property Font;
    property ImeMode;
    property ImeName;
    property ItemHeight;
    property MaxLength;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Sorted;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDropDown;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnStartDock;
    property OnStartDrag;
    property Items; { Must be published after OnMeasureItem }
  end;



implementation
{$R FontComboBox.res}

{ TFontComboBox }

constructor TFontComboBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Style := csOwnerDrawFixed;
  Items := screen.Fonts ;
end;


procedure TFontComboBox.DrawItem(Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
begin
//  if (csDesigning in ComponentState) then
//    inherited DrawItem(Index, Rect, State)
//  else
  with Canvas do
  begin
      FillRect(Rect);
      if DroppedDown then
        begin
          Font.Name := Items[Index];
          TextOut(Rect.Left +8 + 13, Rect.Top+2, Items[Index]);
        end
      else
        begin
          Font.Name := Items[Index];
          TextOut(Rect.Left+6+4, Rect.Top+2, Items[Index]);
        end;
  end;
end;

function TFontComboBox.GetFontName: String;
begin
  Result := '';
  if (ItemIndex <> -1) then Result := Trim(Items[ItemIndex]);
end;

procedure TFontComboBox.Loaded;
begin
  inherited Loaded;
end;


procedure TFontComboBox.MeasureItem(Index: Integer; var Height: Integer);
begin
  inherited MeasureItem(Index,Height);

end;

end.
