unit FontListBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFontListBox = class(TCustomListBox)
  private
    { Private declarations }
    FFontHeight:integer;
    function GetFontName:String;
    procedure SetFontHeight(Value:integer);
  protected
    { Protected declarations }
    procedure DrawItem(Index: Integer;
      Rect: TRect; State: TOwnerDrawState);override;
    procedure MeasureItem(Index: Integer;
      var Height: Integer);override;
  public
    { Public declarations }
    property FontName :String read GetFontName ;
    constructor Create(AOwner:TComponent);override;
  published
    { Published declarations }
    property Align;
    property Anchors;
    property BiDiMode;
    property BorderStyle;
    property Color;
    property Columns;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property ExtendedSelect;
    property Font;
    property ImeMode;
    property ImeName;
    property IntegralHeight;
    property ItemHeight;
    property Items;
    property MultiSelect;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Sorted;
    property Style;
    property TabOrder;
    property TabStop;
    property TabWidth;
    property Visible;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    property FontHeight :integer read FFontHeight write SetFontHeight default 18;
  end;


implementation
{$R FontListBox.res}

{ TFontListBox }

constructor TFontListBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Parent:=application.MainForm ;
  Style := lbOwnerDrawFixed;
  Items := screen.Fonts ;
  FFontHeight := 18;
end;

procedure TFontListBox.DrawItem(Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  //if (not Selected[Index]) then
  //  Canvas.Brush.Color := clInfoBk
  //else
  //  Canvas.Brush.Color := clWhite;
  Canvas.FillRect(Rect);
  Canvas.Font.Name := Items[Index];
  Canvas.TextOut(Rect.Left+3, Rect.Top+2,Items[Index]);
end;

function TFontListBox.GetFontName: String;
begin
  Result := '';
  if (self.ItemIndex <> -1) then Result := Trim(self.Items[self.ItemIndex]);
end;

procedure TFontListBox.MeasureItem(Index: Integer;
  var Height: Integer);
begin
   Height := FFontHeight;
   Invalidate;
end;

procedure TFontListBox.SetFontHeight(Value: integer);
begin
  if FFontHeight<>Value then FFontHeight := Value;
  PaintWindow(Canvas.Handle);
end;

end.
