unit WyAbout;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,ShellAPI,
  StdCtrls;

type
  TWyAbout = class(TCommonDialog)
  private
    { Private declarations }
    FTitle:String;
    FText:String;
    FIcon :TIcon;
    procedure SetTitle(Value:string);
    procedure SetText(Value:string);
    procedure SetIcon(Value:TIcon);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
  published
    { Published declarations }
    function Execute:boolean;override;
    property Title:string read FTitle write SetTitle;
    property Text :string read FText write SetText;
    property Icon:TIcon read FIcon write SetIcon;
  end;

  TFontDirection = (fdUp,fdDown,fdLeft,fdRight,fdUpLeft,fdUpRight,fdDownLeft,fdDownRight);
  TLabel3D = class(TCustomLabel)
  private
    { Private declarations }
    FShadeWidth :integer;
    FShadowColor:TColor;
    FFontDirection:TFontDirection;
    //FRotation:boolean;
    //FAngle:integer;
    FAuthor:string;
    procedure SetShadeWidth(Value:Integer);
    procedure SetShadowColor(Value:TColor);
    procedure SetFontDirection(Value:TFontDirection);
    //procedure SetRotation(Value:boolean);
    //procedure SetAngle(Value:integer);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    procedure Paint;override;
  published
    { Published declarations }
    property ShadeWidth :Integer read FShadeWidth write SetShadeWidth;
    property ShadowColor:TColor read FShadowColor write SetShadowColor default clWhite;
    property FontDirection:TFontDirection read FFontDirection write SetFontDirection;
    //property Rotation:boolean read FRotation write SetRotation ;
    //property Angle:integer read FAngle write SetAngle;
    property Author:String read FAuthor;
    property Align;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property Caption;
    property Color;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FocusControl;
    property Font;
    property PopupMenu;
    property ShowAccelChar;
    property ShowHint;
    property Transparent;
    property Layout;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;



implementation
{$R WyAbout.res}


{ TAbout }

constructor TWyAbout.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FIcon := TIcon.Create;
end;

destructor TWyAbout.Destroy;
begin
  inherited;
  FIcon.Free;
end;

function TWyAbout.Execute: boolean;
begin
  ShellAbout(Handle,pchar(FTitle),pchar(FText),FIcon.Handle);
  Result := True;
end;

procedure TWyAbout.SetIcon(Value: TIcon);
begin
  FIcon.Assign(Value);
end;

procedure TWyAbout.SetText(Value: string);
begin
  FText := Value;
end;

procedure TWyAbout.SetTitle(Value: string);
begin
  FTitle := Value;
end;

  { TLabel3D }

constructor TLabel3D.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Parent := Application.MainForm;
  Width := 10;
  Height := 3;
  Font.Size := 14;
  Font.Color := clRed;
  Font.Name := '_GB2312';
  FFontDirection := fdDownRight;
  FShadeWidth := 2;
  FShadowColor := clWhite;
  FAuthor := 'WangYang';
  Transparent := True;
end;

destructor TLabel3D.Destroy;
begin
  inherited;
end;

procedure TLabel3D.Paint;
var
  i:integer;
begin
  inherited Paint;
  case FFontDirection of
    fdUp:
      for i := 1 to FShadeWidth do begin
        Canvas.Font.Color := Font.Color;
        Canvas.TextOut(0,-(i-1),pchar(Caption));
        Canvas.Font.Color := FShadowColor;
        Canvas.TextOut(0,-i,pchar(Caption));
    end;
    fdDown:
      begin
        for i := 1 to FShadeWidth do begin
          Canvas.Font.Color := Font.Color;
          Canvas.TextOut(0,i-1,pchar(Caption));
          Canvas.Font.Color := FShadowColor;
          Canvas.TextOut(0,i,pchar(Caption));
        end;
      end;
    fdLeft:
    for i := 1 to FShadeWidth do begin
        Canvas.Font.Color := Font.Color;
        Canvas.TextOut(-(i-1),0,pchar(Caption));
        Canvas.Font.Color := FShadowColor;
        Canvas.TextOut(-i,0,pchar(Caption));
    end;
    fdRight:
    for i := 1 to FShadeWidth do begin
        Canvas.Font.Color := Font.Color;
        Canvas.TextOut(i-1,0,pchar(Caption));
        Canvas.Font.Color := FShadowColor;
        Canvas.TextOut(i,0,pchar(Caption));
    end;
    fdUpLeft:
    for i := 1 to FShadeWidth do begin
        Canvas.Font.Color := Font.Color;
        Canvas.TextOut(-(i-1),-(i-1),pchar(Caption));
        Canvas.Font.Color := FShadowColor;
        Canvas.TextOut(-i,-i,pchar(Caption));
    end;
    fdUpRight:
    for i := 1 to FShadeWidth do begin
        Canvas.Font.Color := Font.Color;
        Canvas.TextOut(i-1,-(i-1),pchar(Caption));
        Canvas.Font.Color := FShadowColor;
        Canvas.TextOut(i,-i,pchar(Caption));
    end;
    fdDownLeft:
    for i := 1 to FShadeWidth do begin
        Canvas.Font.Color := Font.Color;
        Canvas.TextOut(-(i-1),i-1,pchar(Caption));
        Canvas.Font.Color := FShadowColor;
        Canvas.TextOut(-i,i,pchar(Caption));
    end;
    fdDownRight:
    for i := 1 to FShadeWidth do begin
        Canvas.Font.Color := Font.Color;
        Canvas.TextOut(i-1,i-1,pchar(Caption));
        Canvas.Font.Color := FShadowColor;
        Canvas.TextOut(i,i,pchar(Caption));
    end;
  end;
  {if FRotation then begin
    try
      //tf := TFont.Create;
      //tf.Assign(Font);
      GetObject(Font.Handle, sizeof(lf), @lf);
      lf.lfEscapement := Angle*10;
      lf.lfOrientation := Angle*10;
      Font.Handle := CreateFontIndirect(lf);
      //Font.Assign(tf);
    finally
      ///tf.Free;
    end;
  end; }
end;

{procedure TLabel3D.SetAngle(Value: integer);
begin
  if FAngle <> Value then FAngle := Value;
  Invalidate;
end;  }

procedure TLabel3D.SetFontDirection(Value: TFontDirection);
begin
  if FFontDirection <> Value then FFontDirection := Value;
  Invalidate;
end;

{procedure TLabel3D.SetRotation(Value: boolean);
begin
  if FRotation <> Value then FRotation := Value;
  Invalidate;
end;  }

procedure TLabel3D.SetShadeWidth(Value: Integer);
begin
  if (Value < 0) then begin
    Application.MessageBox(pchar('ЧĲֵ '+String(Value)),pchar(''),MB_OK);
    Exit;
  end;
  FShadeWidth := Value;
  Invalidate;
end;

procedure TLabel3D.SetShadowColor(Value: TColor);
begin
  if FShadowColor<>Value then FShadowColor := Value;
  Invalidate;
end;

end.
