unit WyLaunch;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,ShellAPI;

type
  TShowMode = ( smNormal, smMaximized, smMinimized, smHide );
  TWyLaunch = class(TComponent)
  private
    FParameters: string;
    FAction: string;
    FStartDir: string;
    FShowMode: TShowMode;
    FFileName: String;
    procedure SetFileName(const Value: String);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    procedure Launch; virtual;
  published
    { Published declarations }
    property Action: string read FAction write FAction;
    property FileName: String read FFileName write SetFileName;
    property Parameters: string read FParameters write FParameters;
    property ShowMode: TShowMode read FShowMode write FShowMode default smNormal;
    property StartDir: string read FStartDir write FStartDir;
  end;

const
  ShowWindowModes: array[ TShowMode ] of Integer =
    ( sw_Normal, sw_ShowMaximized, sw_ShowMinimized, sw_Hide );
  CaptionStr:String='';
  TextStr:String='ִļ';


implementation
{$R WyLaunch.Res}


{ TWyLaunch }

constructor TWyLaunch.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FShowMode := smNormal;
  FAction := 'Open';
end;

destructor TWyLaunch.Destroy;
begin
  inherited Destroy;
end;

procedure TWyLaunch.Launch;
var
  ShellInfo: TShellExecuteInfo;
begin

  FillChar( ShellInfo, SizeOf( TShellExecuteInfo ), 0 );
  ShellInfo.cbSize := SizeOf( TShellExecuteInfo );
  ShellInfo.fMask := SEE_MASK_NOCLOSEPROCESS or SEE_MASK_FLAG_NO_UI or
                     SEE_MASK_FLAG_DDEWAIT;
  ShellInfo.Wnd := HWnd_Desktop;
  ShellInfo.lpVerb := PChar( FAction );
  ShellInfo.lpFile := PChar( FFileName );
  ShellInfo.lpParameters := PChar( FParameters );
  ShellInfo.lpDirectory := PChar( FStartDir );
  ShellInfo.nShow := ShowWindowModes[ FShowMode ];

  if not ShellExecuteEx( @ShellInfo ) then
    Application.MessageBox(pchar(TextStr),pchar(CaptionStr),MB_OK);
end;

procedure TWyLaunch.SetFileName(const Value: String);
begin
  FFileName := Value;
end;

end.
