unit WyOnly;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TWyOnly = class(TComponent)
  private
    { Private declarations }
    FSwitchToPrevious: Boolean;
    FOnAlreadyExist: TNotifyEvent;
    HMutex: hWnd;
    Created: Boolean;
  protected
    { Protected declarations }
    procedure Loaded; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property SwitchToPrevious: Boolean read FSwitchToPrevious write FSwitchToPrevious default True;
    property OnAlreadyExist: TNotifyEvent read FOnAlreadyExist write FOnAlreadyExist;
  end;


implementation
{$R WyOnly.res}

{ TWyOnly }

constructor TWyOnly.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FSwitchToPrevious := True;
end;

destructor TWyOnly.Destroy;
begin
  if Created then CloseHandle(HMutex);
  inherited Destroy;
end;

procedure TWyOnly.Loaded;
var
  PrevInstHandle: THandle;
  AppTitle: Array[0..$100] of Char;
begin
  inherited Loaded;

  if csDesigning in ComponentState then Exit;  //ʱ

  StrPCopy(AppTitle, Application.Title);
  Created := False;

  HMutex := CreateMutex(nil, False, AppTitle);
  if (GetLastError = ERROR_ALREADY_EXISTS) or
     (HMutex = 0) then
  begin
   if Assigned(FOnAlreadyExist) then FOnAlreadyExist(Self);

   if FSwitchToPrevious then
    begin
     SetWindowText(Application.Handle, '');

     PrevInstHandle := FindWindow(nil, AppTitle);
     if PrevInstHandle <> 0 then
      if IsIconic(PrevInstHandle) then
        ShowWindow(PrevInstHandle, SW_RESTORE)
      else
        BringWindowToTop(PrevInstHandle);
      SetForegroundWindow(PrevInstHandle);
    end;

   Application.ShowMainForm := False;
   Application.Terminate;
  end;
  Created := True;
end;

end.
