unit WyPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,Jpeg;

type
  TWyMovePanel = class(TPanel)
  private
    FBkGroundImage: TPicture;
    FStretch: boolean;
    { Private declarations }
    procedure MouseDownA(var Message: TWMLBUTTONDOWN); message WM_LBUTTONDOWN;
    procedure SetBkGroundImage(const Value: TPicture);
    procedure SetStretch(const Value: boolean);
  protected
    { Protected declarations }
    procedure Paint; override;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
  published
    { Published declarations }
    property BkGroundImage :TPicture
                read FBkGroundImage
                write SetBkGroundImage;
    property Stretch:boolean
                read FStretch
                write SetStretch;
  end;


implementation

{ TWyMovePanel }

constructor TWyMovePanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FBkGroundImage := TPicture.Create;
end;

destructor TWyMovePanel.Destroy;
begin
  FBkGroundImage.Free;
  inherited Destroy;
end;

procedure TWyMovePanel.MouseDownA(var Message: TWMLBUTTONDOWN);
begin
  if csDesigning in ComponentState then Message.Result := 1;

  if not (TWinControl(self).Parent is TForm) then Exit;

  ReleaseCapture();
  SendMessage(TWinControl(self).Parent.Handle,WM_NCLBUTTONDOWN,htCaption,0);
  Message.Result := 1;
end;

procedure TWyMovePanel.Paint;
var
  dc,tmpdc,olddc:HDC;
begin
  inherited Paint;
  if FBkGroundImage <> nil then begin
    dc := GetDC(Handle);
    tmpdc := CreateCompatibleDC(dc);
    olddc := selectobject(tmpdc,FBkGroundImage.Bitmap.Handle);
    if FStretch then
      StretchBlt(dc,
                 0,
                 0,
                 ClientWidth,
                 ClientHeight,
                 tmpdc,
                 0,
                 0,
                 FBkGroundImage.Bitmap.Width,
                 FBkGroundImage.Bitmap.Height,
                 SrcCopy)
    else
      BitBlt(dc,0,0,ClientWidth,ClientHeight,tmpdc,0,0,SrcCopy);
    selectobject(tmpdc,olddc);
  end;
end;

procedure TWyMovePanel.SetBkGroundImage(const Value: TPicture);
begin
  if Value.Graphic is TJPEGImage then begin
    Application.MessageBox(pchar('ѡλͼļʱ֧JPEGͼ'),pchar('ʾ'),MB_OK);
    Exit;
  end;
  FBkGroundImage.Assign(Value);
end;

procedure TWyMovePanel.SetStretch(const Value: boolean);
begin
  FStretch := Value;
  Invalidate;
end;

end.
