unit WySysMenu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus;
type
  TWySysMenu = class(TComponent)
  private
    menu:HMENU;
    FPopupMenu: TPopupMenu;
    procedure SetPopupMenu(const Value: TPopupMenu);
    procedure wmsyscommand(var cmd:integer);
    procedure msghandler(var msg:tagMsg;var Handled :boolean);
    function IsPopupMsg(cmd:integer):boolean;
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
  published
    { Published declarations }
    property PopupMenu:TPopupMenu read FPopupMenu write SetPopupMenu;
  end;

implementation
{$R WySysMenu.res}


{ TWySysMenu }

constructor TWySysMenu.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  if not (Owner is TForm) then begin
    Application.MessageBox (pchar('ܴϵͳ˵'),pchar(''),MB_OK);
    Exit;
  end;
  menu := GetSystemMenu(TWinControl(Owner).Handle,False);
  if not (csDesigning in ComponentState) then begin
    Application.OnMessage := msghandler;
  end;
end;


function TWySysMenu.IsPopupMsg(cmd: integer): boolean;
var
  I:integer;
begin
  Result := False;
  for I := 0 to FPopupMenu.Items.count -1 do
    if cmd  = FPopupMenu.Items[i].Command then Result := True;
end;    

destructor TWySysMenu.Destroy;
begin
  inherited Destroy;
end;

procedure TWySysMenu.msghandler(var msg: tagMsg; var Handled: boolean);
begin
  if (msg.message = WM_SYSCOMMAND) and IsPopupMsg(msg.wParam)
  then begin
    wmsyscommand(msg.wParam);
    Handled := True;
  end
  else
    DefaultHandler(msg.message);
end;

procedure TWySysMenu.SetPopupMenu(const Value: TPopupMenu);
var
  I:integer;
begin
  FPopupMenu := Value;
  if Assigned(FPopupMenu) then begin
    for I := 0 to FPopupMenu.Items.count -1 do begin
      if not FPopupMenu.Items[i].IsLine then
        AppendMenu(menu,MF_STRING,FPopupMenu.Items[i].Command,pchar(FPopupMenu.Items[i].Caption))
      else
        AppendMenu(menu,MF_SEPARATOR,0,nil);
    end;
  end;
end;

procedure TWySysMenu.wmsyscommand(var cmd:integer);
var
  I:integer;
begin
  for I := 0 to FPopupMenu.Items.count -1 do begin
    if cmd  = FPopupMenu.Items[i].Command then
      FPopupMenu.Items[i].Click
  end;
end;

end.
